# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Consumption::Mgmt::V2018_11_01_preview
  module Models
    #
    # A billing profile resource.
    #
    class BillingProfile < Resource

      include MsRestAzure

      # @return [String] The billing profile name.
      attr_accessor :display_name

      # @return [String] Purchase order number.
      attr_accessor :po_number

      # @return [Address] Billing address.
      attr_accessor :billing_address

      # @return [String] Billing contact.
      attr_accessor :billing_contact

      # @return [Boolean] Email invoice.
      attr_accessor :email_invoice

      # @return [Integer] Invoice day.
      attr_accessor :invoice_day

      # @return [String] Currency on the billing profile.
      attr_accessor :currency


      #
      # Mapper for BillingProfile class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BillingProfile',
          type: {
            name: 'Composite',
            class_name: 'BillingProfile',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              po_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.poNumber',
                type: {
                  name: 'String'
                }
              },
              billing_address: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.billingAddress',
                type: {
                  name: 'Composite',
                  class_name: 'Address'
                }
              },
              billing_contact: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.billingContact',
                type: {
                  name: 'String'
                }
              },
              email_invoice: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.emailInvoice',
                type: {
                  name: 'Boolean'
                }
              },
              invoice_day: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.invoiceDay',
                type: {
                  name: 'Number'
                }
              },
              currency: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.currency',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
