# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Consumption::Mgmt::V2018_11_01_preview
  module Models
    #
    # A charge summary resource by billing profile.
    #
    class ChargeSummaryByBillingProfile < Resource

      include MsRestAzure

      # @return [String] The id of the billing period resource that the usage
      # belongs to.
      attr_accessor :billing_period_id

      # @return [String] Billing period start date.
      attr_accessor :usage_start

      # @return [String] Billing period end date.
      attr_accessor :usage_end

      # @return [Amount] Azure Charges.
      attr_accessor :azure_charges

      # @return [Amount] Charges Billed separately.
      attr_accessor :charges_billed_separately

      # @return [Amount] Marketplace Charges.
      attr_accessor :marketplace_charges

      # @return [String] The id of the billing account resource that the charge
      # belongs to.
      attr_accessor :billing_account_id

      # @return [String] The id of the billing profile resource that the charge
      # belongs to.
      attr_accessor :billing_profile_id

      # @return [String] The id of the invoice section resource that the charge
      # belongs to.
      attr_accessor :invoice_section_id


      #
      # Mapper for ChargeSummaryByBillingProfile class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ChargeSummaryByBillingProfile',
          type: {
            name: 'Composite',
            class_name: 'ChargeSummaryByBillingProfile',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              billing_period_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.billingPeriodId',
                type: {
                  name: 'String'
                }
              },
              usage_start: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.usageStart',
                type: {
                  name: 'String'
                }
              },
              usage_end: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.usageEnd',
                type: {
                  name: 'String'
                }
              },
              azure_charges: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.azureCharges',
                type: {
                  name: 'Composite',
                  class_name: 'Amount'
                }
              },
              charges_billed_separately: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.chargesBilledSeparately',
                type: {
                  name: 'Composite',
                  class_name: 'Amount'
                }
              },
              marketplace_charges: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.marketplaceCharges',
                type: {
                  name: 'Composite',
                  class_name: 'Amount'
                }
              },
              billing_account_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.billingAccountId',
                type: {
                  name: 'String'
                }
              },
              billing_profile_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.billingProfileId',
                type: {
                  name: 'String'
                }
              },
              invoice_section_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.invoiceSectionId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
