# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Consumption::Mgmt::V2018_11_01_preview
  module Models
    #
    # A department resource.
    #
    class Department < Resource

      include MsRestAzure

      # @return [String] The name for department.
      attr_accessor :department_name

      # @return [String] The cost center name.
      attr_accessor :cost_center

      # @return [String] The status for department.
      attr_accessor :status

      # @return [Array<EnrollmentAccount>] Associated enrollment accounts. By
      # default this is not populated, unless it's specified in $expand.
      attr_accessor :enrollment_accounts


      #
      # Mapper for Department class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Department',
          type: {
            name: 'Composite',
            class_name: 'Department',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              department_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.departmentName',
                type: {
                  name: 'String'
                }
              },
              cost_center: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.costCenter',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.status',
                type: {
                  name: 'String'
                }
              },
              enrollment_accounts: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.enrollmentAccounts',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'EnrollmentAccountElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'EnrollmentAccount'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
