# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Consumption::Mgmt::V2019_10_01
  module Models
    #
    # Modern charge summary.
    #
    class ModernChargeSummary < ChargeSummary

      include MsRestAzure


      def initialize
        @kind = "modern"
      end

      attr_accessor :kind

      # @return [String] The id of the billing period resource that the charge
      # belongs to.
      attr_accessor :billing_period_id

      # @return [String] Usage start date.
      attr_accessor :usage_start

      # @return [String] Usage end date.
      attr_accessor :usage_end

      # @return [Amount] Azure Charges.
      attr_accessor :azure_charges

      # @return [Amount] Charges Billed separately.
      attr_accessor :charges_billed_separately

      # @return [Amount] Marketplace Charges.
      attr_accessor :marketplace_charges

      # @return [String] Billing Account Id
      attr_accessor :billing_account_id

      # @return [String] Billing Profile Id
      attr_accessor :billing_profile_id

      # @return [String] Invoice Section Id
      attr_accessor :invoice_section_id

      # @return [String] Customer Id
      attr_accessor :customer_id

      # @return [Boolean] Is charge Invoiced
      attr_accessor :is_invoiced


      #
      # Mapper for ModernChargeSummary class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'modern',
          type: {
            name: 'Composite',
            class_name: 'ModernChargeSummary',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              billing_period_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.billingPeriodId',
                type: {
                  name: 'String'
                }
              },
              usage_start: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.usageStart',
                type: {
                  name: 'String'
                }
              },
              usage_end: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.usageEnd',
                type: {
                  name: 'String'
                }
              },
              azure_charges: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.azureCharges',
                type: {
                  name: 'Composite',
                  class_name: 'Amount'
                }
              },
              charges_billed_separately: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.chargesBilledSeparately',
                type: {
                  name: 'Composite',
                  class_name: 'Amount'
                }
              },
              marketplace_charges: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.marketplaceCharges',
                type: {
                  name: 'Composite',
                  class_name: 'Amount'
                }
              },
              billing_account_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.billingAccountId',
                type: {
                  name: 'String'
                }
              },
              billing_profile_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.billingProfileId',
                type: {
                  name: 'String'
                }
              },
              invoice_section_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.invoiceSectionId',
                type: {
                  name: 'String'
                }
              },
              customer_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.customerId',
                type: {
                  name: 'String'
                }
              },
              is_invoiced: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.isInvoiced',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
